package org.netbeans.modules.cnd.dwarfdump.dump;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.List;

import org.netbeans.modules.cnd.dwarfdump.CompilationUnit;
import org.netbeans.modules.cnd.dwarfdump.Dwarf;
import org.netbeans.modules.cnd.dwarfdump.exception.WrongFileFormatException;

public class DumpDwarf {

	public static void main(String[] args) {
        String objFileName = args[0];
        Dwarf dump = null;
        try {
            System.out.println("DumpDwarf.");  // NOI18N
            dump = new Dwarf(objFileName);
            List<CompilationUnit> units = dump.getCompilationUnits();
            System.out.println("\n**** Done. " + units.size() + " compilation units were found:"); // NOI18N
            int idx = 0;
            if (units.size() > 0) {
                for (CompilationUnit compilationUnit : units) {
                    System.out.println(++idx + ": " + compilationUnit.getSourceFileName());// NOI18N
                    compilationUnit.dump(System.out);
                }
            }
        } catch (FileNotFoundException ex) {
            // Skip Exception
            System.out.println("File not found " + objFileName + ": " + ex.getMessage());  // NOI18N
        } catch (WrongFileFormatException ex) {
            System.out.println("Unsuported format of file " + objFileName + ": " + ex.getMessage());  // NOI18N
        } catch (IOException ex) {
            System.err.println("Exception in file " + objFileName);  // NOI18N
            ex.printStackTrace();
        } catch (Exception ex) {
            System.err.println("Exception in file " + objFileName);  // NOI18N
            ex.printStackTrace();
        } finally {
            if (dump != null) {
                dump.dispose();
            }
        }
	}
}
